<?php
// $Id: flickrrippr.inc,v 1.12.2.3 2010/07/10 02:56:11 taniwha Exp $

/**
 * @file flickrriprr.inc 
 * Functions that are likely to be of use to other modules, are in this file.
 * PHP Flickr: http://phpflickr.com/docs/
 * Flickr API docs http://www.flickr.com/services/api/
 */
//
//
///**
// * Works out img tags to display a photo - optionally wrapped in a link to the photo's page.
// * NOTE: flickr requires links to flickr.com if you're not caching the file on your own server
// */
/**
* Helper function, to get drupal user details for a flickr user (string of their username of flickr)
*/
function flickrrippr_get_user_by_flickrusername($fuser) {
  if (!$fuser) {
    drupal_set_message(t("Refusing to search for blank username"));
    return;
  }
  
  $flickruser = db_fetch_object(db_query("SELECT * FROM {flickrusers} WHERE LOWER(flickrusername) = '%s'", strtolower($fuser)));
  if (!$flickruser) {
    drupal_set_message(t("Flickruser %flickrusername is not a registered user of this site", array('%flickrusername' => $fuser)));
    return;
  }
  
  $user = user_load(array('uid' => $flickruser->uid));
  return $user;
}



/**
* Work out the path to a photo - also handles the cache on the local filesystem
*/
function flickrrippr_path($flickr_photo, $cache = TRUE, $size = FALSE) {


 //http://farm{farm-id}.static.flickr.com/{server-id}/{id}_{secret}.jpg
  $src =  'http://farm'. $flickr_photo['farm'] .'.static.flickr.com/'. $flickr_photo['server'] .'/'. $flickr_photo['id'] .'_'. $flickr_photo['secret'] . ($size ? '_'. $size : '') .'.jpg';
  
  if (!$cache) {
    return $src;
  }
  return $src;

 $folder =  file_directory_path() . '/flickr';
 if (!file_create_path($folder)) {
   drupal_set_message(t('Files directory not set, unable to cache flickr photos'), 'error');
   return;
 }
  
  $filename =  $folder .'/'. $flickr_photo['id'] .'_'. $flickr_photo['secret'] . ($size ? '_'. $size : '') .'.jpg';
  
 //If we've already go it, then we dont' need to get it
  if (file_exists($filename)) {
   //if (filesize($filename) > 0) {
     //TODO, check mtime against photo info -- if possible
    return $filename;
   //}
  }
  
  require_once "HTTP/Request.php";
  $req =& new HTTP_Request($src);
   //Something went wrong?
  if (PEAR::isError($req->sendRequest())) {
    drupal_set_message(t("Failed to retrieve jpeg file from flick.com, url = %url", array('%url' => $src)));
   //use flickr hosted jpeg
    return $src;
  }
  
   //file handle to save the jpeg into
  $contents = $req->getResponseBody();
  if (file_save_data($contents, $filename, FILE_EXISTS_REPLACE)) {
    return $filename;
  }
  else {
    drupal_set_message(t("Failed to save image to %filename", array('%filename' => $filename)));
    return $src;
  }
 
}
